//these classes are part of the RedSample package
//preloads buffer into ram

RedSampler : RedAbstractSampler {					//playing buffers in ram
	*initClass {
		StartUp.add{
			2.do{|i|								//change here for more channels than stereo
				SynthDef.writeOnce("redSampler-"++(i+1), {
					|i_out= 0, bufnum, amp= 0.7, attack= 0.01, sustain, release= 0.1, gate= 1, offset= 0|
					var src= PlayBuf.ar(
						i+1,
						bufnum,
						BufRateScale.ir(bufnum),
						1,
						BufFrames.ir(bufnum)*offset
					);
					var env= EnvGen.kr(
						Env(#[0, 1, 1, 0], [attack, sustain, release], -4),
						gate,
						amp,
						0,
						1,
						2						//doneAction
					);
					Out.ar(i_out, src*env);
				}, [\ir]);
			}
		}
	}
	prCreateVoice {|sf, startFrame|
		^RedSamplerVoice(server, sf.path, sf.numChannels, startFrame, nil, sf.duration);
	}
}

RedSamplerVoice : RedAbstractSamplerVoice {
	defName {^"redSampler-"++channels}
	play {|attack, sustain, release, amp, out, group|
		isPlaying= true;
		synth= Synth.head(group ?? {server.defaultGroup}, this.defName, [
			\i_out, out,
			\bufnum, buffer.bufnum,
			\amp, amp,
			\attack, attack,
			\sustain, sustain ?? {(length-attack-release).max(0)},
			\release, release
		]);
		OSCresponderNode(server.addr, '/n_end', {|t, r, m|
			if(m[1]==synth.nodeID, {
				isPlaying= false;
				isReleased= false;
				r.remove;
			});
		}).add;
	}
	prAllocBuffer {|action|
		buffer= Buffer.read(server, path, startFrame, -1, action)
	}
}
